
 #ifndef t6963c_H
#define t6963c_H
// port danych
#define T6963_D0 		24

// port sygnaw sterujcych

// sygnay sterujace
#define T6963_WR			(1 << 16)
#define T6963_RD			(1 << 13)
#define T6963_CE			(1 << 15)
#define T6963_CD			(1 << 12)
#define T6963_RESET			(1 << 14)
#define T6963_FS			(1 << 22)
// parametry wywietlacza
#define GLCD_NUMBER_OF_LINES			    128
#define GLCD_PIXELS_PER_LINE				240
#define GLCD_FONT_WIDTH						5

#define GLCD_GRAPHIC_AREA					(GLCD_PIXELS_PER_LINE / GLCD_FONT_WIDTH)
#define GLCD_TEXT_AREA						(GLCD_PIXELS_PER_LINE / GLCD_FONT_WIDTH)
#define GLCD_GRAPHIC_SIZE					(GLCD_GRAPHIC_AREA * GLCD_NUMBER_OF_LINES)
#define GLCD_TEXT_SIZE						(GLCD_TEXT_AREA * (GLCD_NUMBER_OF_LINES/8))


#define GLCD_TEXT_HOME						0
#define GLCD_GRAPHIC_HOME					(GLCD_TEXT_HOME + GLCD_TEXT_SIZE)
#define GLCD_OFFSET_REGISTER				2
#define GLCD_EXTERNAL_CG_HOME				(GLCD_OFFSET_REGISTER << 11)


#define T6963_SET_CURSOR_POINTER			0x21
#define T6963_SET_OFFSET_REGISTER			0x22
#define T6963_SET_ADDRESS_POINTER			0x24

#define T6963_SET_TEXT_HOME_ADDRESS			0x40
#define T6963_SET_TEXT_AREA					0x41
#define T6963_SET_GRAPHIC_HOME_ADDRESS		0x42
#define T6963_SET_GRAPHIC_AREA				0x43

#define T6963_MODE_SET						0x80


#define T6963_DISPLAY_MODE					0x90
	#define T6963_CURSOR_BLINK_ON			0x01
	#define T6963_CURSOR_DISPLAY_ON			0x02
	#define T6963_TEXT_DISPLAY_ON			0x04
	#define T6963_GRAPHIC_DISPLAY_ON		0x08				

//#define T6963_
//#define T6963_

#define T6963_CURSOR_PATTERN_SELECT			0xA0
	#define T6963_CURSOR_1_LINE				0x00
	#define T6963_CURSOR_2_LINE				0x01
	#define T6963_CURSOR_3_LINE				0x02
	#define T6963_CURSOR_4_LINE				0x03
	#define T6963_CURSOR_5_LINE				0x04
	#define T6963_CURSOR_6_LINE				0x05
	#define T6963_CURSOR_7_LINE				0x06
	#define T6963_CURSOR_8_LINE				0x07

#define T6963_SET_DATA_AUTO_WRITE			0xB0
#define T6963_SET_DATA_AUTO_READ			0xB1
#define T6963_AUTO_RESET					0xB2

#define T6963_DATA_WRITE_AND_INCREMENT		0xC0
#define T6963_DATA_READ_AND_INCREMENT		0xC1
#define T6963_DATA_WRITE_AND_DECREMENT		0xC2
#define T6963_DATA_READ_AND_DECREMENT		0xC3
#define T6963_DATA_WRITE_AND_NONVARIALBE	0xC4
#define T6963_DATA_READ_AND_NONVARIABLE		0xC5

#define T6963_SCREEN_PEEK					0xE0
#define T6963_SCREEN_COPY					0xE8

 void GLCD_Write_num(int num);
 void GLCD_Rectangle(unsigned char x, unsigned char y, unsigned char b, unsigned char a);
void GLCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius);
void GLCD_Line(int X1, int Y1,int X2,int Y2);
int GLCD_Chceck_Status(void);
void GLCD_Write_Command(unsigned char byte);
void GLCD_Write_Data(unsigned char byte);
int GLCD_Read_Data(void);
void GLCD_Clear_Text(void);
void GLCD_Clear_CG(void);
void GLCD_Clear_Graphic(void);
void GLCD_Write_Char(char ch);
void GLCD_Write_String(char * str);
//void GLCD_Write_StringPgm(prog_char * str);
void GLCD_Text_GoTo(int x, int y);
void GLCD_Define_Character(int charCode, int * defChar);
void GLCD_Initalize(void);
void GLCD_SetPixel(int x, int y, int color);

 

   unsigned int read_x(void)
{
int x;
 config_adc(0x04);
PORTA_OUTPUT= PA18;
PORTA_OUTPUT= PA20;
PDRA =PA17;
PDRA =PA19;
RST_PORTA=PA20;
SET_PORTA=PA18;
x= read_adc(2);

 return(x);
 }

    unsigned int read_y(void)
{
int y;
config_adc(0x02);
PORTA_OUTPUT= PA17;
PORTA_OUTPUT= PA19;
PDRA =PA18;
PDRA =PA20;
RST_PORTA=PA19;
SET_PORTA=PA17;
y = read_adc(1);
 return(y);
 }
unsigned char inByte(void)
{
*AT91C_PIOA_PER=*AT91C_PIOA_ODR=(AT91C_PIO_PA24 | AT91C_PIO_PA25 | AT91C_PIO_PA26|AT91C_PIO_PA27 | AT91C_PIO_PA28 | AT91C_PIO_PA29|AT91C_PIO_PA30 | AT91C_PIO_PA31 );
return ((*AT91C_PIOA_PDSR >> T6963_D0) & 0xFF);
}


// funkcja wprowadzajca opnienie zapewniajce 
// spenienie wymaga czasowych sterownika T6963C

void delay(void)
{
volatile int i;
for(i = 0; i < 60; i++);
}

char color = 1;

// funkcja odczytujca bajt statusu wywietlacza
int GLCD_Chceck_Status(void)
{
int tmp;

*AT91C_PIOA_CODR=( T6963_CE | T6963_RD);
delay();

tmp = inByte();

*AT91C_PIOA_SODR=( T6963_CE | T6963_RD);

return tmp;
}

// funkcja zapisu rozkazu do sterownika
void GLCD_Write_Command(unsigned char byte)
{
while(!(GLCD_Chceck_Status()&0x03));

*AT91C_PIOA_PER=(AT91C_PIO_PA24 | AT91C_PIO_PA25 | AT91C_PIO_PA26|AT91C_PIO_PA27 | AT91C_PIO_PA28 | AT91C_PIO_PA29|AT91C_PIO_PA30 | AT91C_PIO_PA31 );
  *AT91C_PIOA_OER =	(AT91C_PIO_PA24 | AT91C_PIO_PA25 | AT91C_PIO_PA26|AT91C_PIO_PA27 | AT91C_PIO_PA28 | AT91C_PIO_PA29|AT91C_PIO_PA30 | AT91C_PIO_PA31 );
*AT91C_PIOA_SODR = (byte << T6963_D0);
byte ^= 0xFF;
*AT91C_PIOA_CODR = (byte << T6963_D0);

*AT91C_PIOA_CODR=( T6963_CE | T6963_WR);
delay();
*AT91C_PIOA_SODR=( T6963_CE | T6963_WR);
}


void GLCD_Write_Data(unsigned char byte)
{
while(!(GLCD_Chceck_Status()&0x03));
*AT91C_PIOA_CODR=(T6963_WR | T6963_CD);
*AT91C_PIOA_PER=(AT91C_PIO_PA24 | AT91C_PIO_PA25 | AT91C_PIO_PA26|AT91C_PIO_PA27 | AT91C_PIO_PA28 | AT91C_PIO_PA29|AT91C_PIO_PA30 | AT91C_PIO_PA31 );
  *AT91C_PIOA_OER =	(AT91C_PIO_PA24 | AT91C_PIO_PA25 | AT91C_PIO_PA26|AT91C_PIO_PA27 | AT91C_PIO_PA28 | AT91C_PIO_PA29|AT91C_PIO_PA30 | AT91C_PIO_PA31 );
*AT91C_PIOA_SODR = (byte << T6963_D0);
byte ^= 0xFF;
*AT91C_PIOA_CODR = (byte << T6963_D0);
  *AT91C_PIOA_CODR=( T6963_CE);

delay();
*AT91C_PIOA_SODR=( T6963_CE | T6963_WR | T6963_CD);
}

int GLCD_Read_Data(void)
{
int tmp;
while(!(GLCD_Chceck_Status()&0x03));

*AT91C_PIOA_CODR=( T6963_CE | T6963_RD | T6963_CD);
delay();
tmp = inByte();
*AT91C_PIOA_SODR=( T6963_CE | T6963_RD | T6963_CD);
return tmp;
}

void GLCD_Clear_Text(void)
{
int i;
GLCD_Write_Data(GLCD_TEXT_HOME);
GLCD_Write_Data(GLCD_TEXT_HOME >> 8);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);

for(i = 0; i < GLCD_TEXT_SIZE; i++)
  {
  GLCD_Write_Data(0);
  GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
  }
}

void GLCD_Clear_CG(void)
{
int i;
GLCD_Write_Data(GLCD_EXTERNAL_CG_HOME & 0xFF);
GLCD_Write_Data(GLCD_EXTERNAL_CG_HOME >> 8);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);

for(i = 0; i < 256 * 8; i++)
  {
  GLCD_Write_Data(0);
  GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
  }
}


void GLCD_Clear_Graphic(void)
{
int i;
GLCD_Write_Data(GLCD_GRAPHIC_HOME & 0xFF);
GLCD_Write_Data(GLCD_GRAPHIC_HOME >> 8);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);

for(i = 0; i < GLCD_GRAPHIC_SIZE; i++)
  {
  GLCD_Write_Data(0x00);
  GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
  }
}

 void GLCD_Write_num(int num)
{
 int i,j;
   int p,f=0;
   char ch[5];
 if (num==0)
  GLCD_Write_Char(48);
  
 for(i=0;i<5;i++)
   { 
     p=1;
     for(j=4-i;j>0;j--)
       p = p*10;
     ch[i] = (num/p);
	 if (num>=p && !f){
	  f=1; 
	 }
     num =num - ch[i] *p ;
	 ch[i] = ch[i] +48;
     if(f) GLCD_Write_Char(ch[i]);
   }
}
void GLCD_Write_Char(char ch)
{
GLCD_Write_Data(ch - 32);
GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
}

void GLCD_Write_String(char * str)
{
while(*str)
  {
  GLCD_Write_Char(*str++);
  }
}

void GLCD_Text_GoTo(int x, int y)
{
int address;

address = GLCD_TEXT_HOME +  x + (GLCD_TEXT_AREA * y);

GLCD_Write_Data(address);
GLCD_Write_Data(address >> 8);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);
}

void GLCD_Define_Character(int charCode, int * defChar)
{
int address;
int i; 

address = GLCD_EXTERNAL_CG_HOME + (8 * charCode);

GLCD_Write_Data(address);
GLCD_Write_Data(address >> 8);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);

for(i = 0; i < 8 ; i++)
  {
  GLCD_Write_Data(*(defChar + i));
  GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
  }
}

void GLCD_Initalize(void)
{
volatile int i;
//GLCD_CTRL_PORT &= ~(1 << GLCD_RESET);
//_delay_ms(1);
//GLCD_CTRL_PORT |= (1 << GLCD_RESET);
*AT91C_PMC_PCER= (1 << AT91C_ID_PIOA);

*AT91C_PIOA_PER=*AT91C_PIOA_OER= (T6963_RD | T6963_WR | T6963_CD| T6963_CE|T6963_FS | T6963_RESET);
*AT91C_PIOA_SODR= (T6963_RD | T6963_WR | T6963_CD| T6963_CE|T6963_FS | T6963_RESET);
*AT91C_PIOA_PER=(AT91C_PIO_PA24 | AT91C_PIO_PA25 | AT91C_PIO_PA26|AT91C_PIO_PA27 | AT91C_PIO_PA28 | AT91C_PIO_PA29|AT91C_PIO_PA30 | AT91C_PIO_PA31 );
*AT91C_PIOA_OER =(AT91C_PIO_PA24 | AT91C_PIO_PA25 | AT91C_PIO_PA26|AT91C_PIO_PA27 | AT91C_PIO_PA28 | AT91C_PIO_PA29|AT91C_PIO_PA30 | AT91C_PIO_PA31 );



*AT91C_PIOA_CODR= T6963_RESET;
for(i = 0; i < 1000; i++);
*AT91C_PIOA_SODR= T6963_RESET;

#if (GLCD_FONT_WIDTH == 8)
*AT91C_PIOA_CODR=(T6963_FS);
#endif

GLCD_Write_Data(GLCD_GRAPHIC_HOME & 0xFF);
GLCD_Write_Data(GLCD_GRAPHIC_HOME >> 8);
GLCD_Write_Command(T6963_SET_GRAPHIC_HOME_ADDRESS);


GLCD_Write_Data(GLCD_GRAPHIC_AREA);
GLCD_Write_Data(0x00);
GLCD_Write_Command(T6963_SET_GRAPHIC_AREA);


GLCD_Write_Data(GLCD_TEXT_HOME);
GLCD_Write_Data(GLCD_TEXT_HOME >> 8);
GLCD_Write_Command(T6963_SET_TEXT_HOME_ADDRESS);

GLCD_Write_Data(GLCD_TEXT_AREA);
GLCD_Write_Data(0x00);
GLCD_Write_Command(T6963_SET_TEXT_AREA);

GLCD_Write_Data(GLCD_OFFSET_REGISTER);
GLCD_Write_Data(0x00);
GLCD_Write_Command(T6963_SET_OFFSET_REGISTER);


GLCD_Write_Data(0);
GLCD_Write_Data(0);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);

GLCD_Write_Command(T6963_DISPLAY_MODE  | T6963_GRAPHIC_DISPLAY_ON   | T6963_TEXT_DISPLAY_ON /*| T6963_CURSOR_DISPLAY_ON*/);

GLCD_Write_Command(T6963_MODE_SET | 0);

}

void GLCD_SetPixel(int x, int y, int color)
{
int tmp;
int address;

address = GLCD_GRAPHIC_HOME + (x / GLCD_FONT_WIDTH) + (GLCD_GRAPHIC_AREA * y);

GLCD_Write_Data(address & 0xFF);
GLCD_Write_Data(address >> 8);
GLCD_Write_Command(T6963_SET_ADDRESS_POINTER);

GLCD_Write_Command(T6963_DATA_READ_AND_NONVARIABLE);
tmp = GLCD_Read_Data();

if(color)
  tmp |= (1 <<  (GLCD_FONT_WIDTH - 1 - (x % GLCD_FONT_WIDTH)));
else
 tmp &= ~(1 <<  (GLCD_FONT_WIDTH - 1 - (x % GLCD_FONT_WIDTH)));

GLCD_Write_Data(tmp);
GLCD_Write_Command(T6963_DATA_WRITE_AND_INCREMENT);
}
 
void GLCD_Rectangle(unsigned char x, unsigned char y, unsigned char b, unsigned char a)
{
  unsigned char j; // zmienna pomocnicza
  // rysowanie linii pionowych (boki)
  for (j = 0; j < a; j++) {
		GLCD_SetPixel(x, y + j, color);
		GLCD_SetPixel(x + b - 1, y + j, color);
	}
  // rysowanie linii poziomych (podstawy)
  for (j = 0; j < b; j++)	{ 
		GLCD_SetPixel(x + j, y, color);
		GLCD_SetPixel(x + j, y + a - 1, color);
	}
}


void GLCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius)
{
int x, y, xchange, ychange, radiusError;
x = radius;
y = 0;
xchange = 1 - 2 * radius;
ychange = 1;
radiusError = 0;
while(x >= y)
  {
  GLCD_SetPixel(cx+x, cy+y, color); 
  GLCD_SetPixel(cx-x, cy+y, color); 
  GLCD_SetPixel(cx-x, cy-y, color);
  GLCD_SetPixel(cx+x, cy-y, color); 
  GLCD_SetPixel(cx+y, cy+x, color); 
  GLCD_SetPixel(cx-y, cy+x, color); 
  GLCD_SetPixel(cx-y, cy-x, color); 
  GLCD_SetPixel(cx+y, cy-x, color); 
  y++;
  radiusError += ychange;
  ychange += 2;
  if ( 2*radiusError + xchange > 0 )
    {
    x--;
	radiusError += xchange;
	xchange += 2;
	}
  }
}


void GLCD_Line(int X1, int Y1,int X2,int Y2)
{
int CurrentX, CurrentY, Xinc, Yinc, 
    Dx, Dy, TwoDx, TwoDy, 
	TwoDxAccumulatedError, TwoDyAccumulatedError;

Dx = (X2-X1); // obliczenie skadowej poziomej
Dy = (Y2-Y1); // obliczenie skadowej pionowej

TwoDx = Dx + Dx; // podwojona skadowa pozioma
TwoDy = Dy + Dy; // podwojona skadowa pionowa

CurrentX = X1; // zaczynamy od X1
CurrentY = Y1; // oraz Y1

Xinc = 1; // ustalamy krok zwikszania pozycji w poziomie 
Yinc = 1; // ustalamy krok zwikszania pozycji w pionie

if(Dx < 0) // jesli skadowa pozioma jest ujemna 
  {
  Xinc = -1; // to bdziemy si "cofa" (krok ujemny)
  Dx = -Dx;  // zmieniamy znak skadowej na dodatni
  TwoDx = -TwoDx; // jak rwnie podwojonej skadowej
  }

if (Dy < 0) // jeli skadowa pionowa jest ujemna
  {
  Yinc = -1; // to bdziemy si "cofa" (krok ujemny)
  Dy = -Dy; // zmieniamy znak skadowej na dodatki
  TwoDy = -TwoDy; // jak rwniez podwojonej skadowej
  }

GLCD_SetPixel(X1,Y1, color); // stawiamy pierwszy krok (zapalamy pierwszy piksel)

if ((Dx != 0) || (Dy != 0)) // sprawdzamy czy linia skada si z wicej ni jednego punktu ;)
  {
  // sprawdzamy czy skadowa pionowa jest mniejsza lub rwna skadowej poziomej
  if (Dy <= Dx) // jeli tak, to idziemy "po iksach"
    { 
    TwoDxAccumulatedError = 0; // zerujemy zmienn 
    do // ruszamy w drog
	  {
      CurrentX += Xinc; // do aktualnej pozycji dodajemy krok 
      TwoDxAccumulatedError += TwoDy; // a tu dodajemy podwojon skadow pionow
      if(TwoDxAccumulatedError > Dx)  // jeli TwoDxAccumulatedError jest wikszy od Dx
        {
        CurrentY += Yinc; // zwikszamy aktualn pozycj w pionie
        TwoDxAccumulatedError -= TwoDx; // i odejmujemy TwoDx
        }
       GLCD_SetPixel(CurrentX,CurrentY, color);// stawiamy nastpny krok (zapalamy piksel)
       }while (CurrentX != X2); // idziemy tak dugo, a osigniemy punkt docelowy
     }
   else // w przeciwnym razie idziemy "po igrekach" 
      {
      TwoDyAccumulatedError = 0; 
      do 
	    {
        CurrentY += Yinc; 
        TwoDyAccumulatedError += TwoDx;
        if(TwoDyAccumulatedError>Dy) 
          {
          CurrentX += Xinc;
          TwoDyAccumulatedError -= TwoDy;
          }
         GLCD_SetPixel(CurrentX,CurrentY, color); 
         }while (CurrentY != Y2);
    }
  }
}
 #endif
